//image scanner by: gijs gieskes 2008
//upload to arduino
//scans images to processing, using 24 LDRs
//combine with isScannerProcessing.pde for processing.
//for info go here: http://gieskes.nl

int noteOnRange = 0;

//multiplex variables
int multiArray[3][8] = {
                     {0,0,0,0,0,0,0,0},
                     {0,0,0,0,0,0,0,0},
                     {0,0,0,0,0,0,0,0}
                     };

void setup() {
  DDRB = DDRB | B00000111;  // 10, 9, 8 zijn outputs
  Serial.begin(9600);
}

void loop() {

    readAnalogs();
    noteOnRange = analogRead(5);
    
    byte teller = 0;
    for(byte i=0; i<3; i++){    
      for(byte j=0; j<8; j++){
        
        Serial.print(teller, BYTE);
        
        int avals = multiArray[i][j];
        avals = constrain(avals, 0, noteOnRange);
        avals = map(avals, 0, noteOnRange, 25, 255);
        avals = constrain(avals, 25, 255);
        Serial.print(avals, BYTE);
        teller++;
      }
    }
    delay(10);
}

//lees de multiplex LDRs in
void readAnalogs(){
  for(byte i=0; i<8; i++){
    PORTB &= B11111000;
    PORTB |= i;                         //schijf naar poort 10,9,8 
    delayMicroseconds(3);               //geef de multiplexor de teid om te schakelen..
    multiArray[0][i] = analogRead(0);
    multiArray[1][i] = analogRead(1);
    multiArray[2][i] = analogRead(2);
  }
}
